/*
 * Downloaded from lenkaspace.net
 * 
 * Paper about this project: http://lenkaspace.net/papers/iteratedPrisonersDilemmaNeuralNetworks.php
 * Email: contact@lenkaspace.net
 */

package net.lenkaspace.prisonersnorecognition;

import java.awt.Component;
import java.awt.Dimension;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextPane;

import net.lenkaspace.prisonersnorecognition.model.World;

public class OutputPanel extends JPanel  {
	
	private JTextPane outputLarge;
	private JTextArea outputSmall;
	JScrollPane scroll1;
	
	protected World mWorld;
	
	public OutputPanel (PrisonersNoRecognition controller_) {
		
		
		this.setBounds(0, 0, 700, Settings.WINDOW_H-40);
		this.setSize (700,Settings.WINDOW_H-40);
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		outputLarge = new JTextPane();
		
		outputLarge.setPreferredSize(new Dimension(700, 500));
		String startText = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ W E L C O M E ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
		startText +=       "                                                       to artificial evolution of cooperation\n";
		startText +=       "                                                         in the Iterated Prisoner's Dilemma\n";
		startText +=       "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
		outputLarge.setText(startText);
		
		scroll1 = new JScrollPane(outputLarge);
		scroll1.setPreferredSize(new Dimension(700, 500));
		scroll1.setAlignmentX(Component.LEFT_ALIGNMENT);
		this.add(scroll1);
		this.add(Box.createVerticalStrut(20)); 
		
		outputSmall = new JTextArea();
		outputSmall.setAlignmentX(Component.LEFT_ALIGNMENT);
		outputSmall.setPreferredSize(new Dimension(700, 50));
		outputSmall.setText("");
		this.add(outputSmall);
		
	
		
	}
	
	
	/** scroll text up to see latest text appended */
	  public void scrollUp()
	    {
	      JScrollBar vbar = scroll1.getVerticalScrollBar();
	      vbar.setValue(vbar.getMaximum());
	    }
		
	//================================================================ FUNCTIONALITY
	public void resetOutputs() {
		this.outputSmall.setText("");
		this.outputLarge.setText("");
	}
	
	public void displayTextInLargeOutput(String text_) {
		this.outputLarge.setText(this.outputLarge.getText() + text_ + "\n");
	}
	
	public void displayTextInSmallOutput(String text_) {
		this.outputSmall.setText(text_);
	}
	
	//============================================================== GETTERS / SETTERS
	public void setWorld(World world_) {
	   mWorld = world_;
	}
	 
	 
	public void setOutputSmall(JTextArea outputSmall) {
		this.outputSmall = outputSmall;
	}
	public JTextArea getOutputSmall() {
		return outputSmall;
	}
	
}



